#include <TextControl.h>
#include <Window.h>
#include <InterfaceKit.h>
#include "pluginproto.h"

#define BUTTON_MSG 'PRES'
#define PLUGINID "sp-suenos"
#define GOTOSLEEP "Go to bed!"
#define STAYUPLATE "Stop"

	
class SoundPlaySuenosWindow : public BWindow {
	private:
		PlaylistPtr 	 	track;
		BTextControl	 	*minutesUntilSleep;
		float				currentVolume;
		bool				fallingAsleep;
		bigtime_t			napForMicroseconds;
		thread_id			fThreadID;
		BButton				*GoToBedButton;
	public:
		SoundPlaySuenosWindow(SoundPlayController *);
		virtual ~SoundPlaySuenosWindow();
		virtual void MessageReceived(BMessage *mes);
		virtual bool QuitRequested();
		virtual void Show();
		void StartCountdown(float minutes);
		bool StopCountdown(void);
		void LowerVolume(float thismuch);
		static int32 FallingAsleepThreadFunc(void *arg);
		
		SoundPlayController *ctrl;
};